Index: kaffe/kaffevm/classMethod.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/classMethod.c,v
retrieving revision 1.93
diff -w -u -p -r1.93 classMethod.c
--- kaffe/kaffevm/classMethod.c	18 Oct 2002 13:54:14 -0000	1.93
+++ kaffe/kaffevm/classMethod.c	27 Dec 2002 22:21:14 -0000
@@ -485,7 +485,7 @@ DBG(STATICINIT,
 DBG(STATICINIT,
 			dprintf("using callMethodA\n");
     )
-			callMethodA(meth, METHOD_INDIRECTMETHOD(meth), 0, 0, 0, 1);
+			callMethodA(meth, 0, 0, 0, 1);
 		}
 
 		lockClass(class);
Index: kaffe/kaffevm/jni.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jni.c,v
retrieving revision 1.80
diff -w -u -p -r1.80 jni.c
--- kaffe/kaffevm/jni.c	18 Oct 2002 13:54:14 -0000	1.80
+++ kaffe/kaffevm/jni.c	27 Dec 2002 22:21:15 -0000
@@ -475,7 +475,7 @@ Kaffe_NewObjectV(JNIEnv* env, jclass cls
 	}
 	obj = newObject(clazz);
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	ADD_REF(obj);
 	END_EXCEPTION_HANDLING();
@@ -515,7 +515,7 @@ Kaffe_NewObjectA(JNIEnv* env, jclass cls
 	}
 	obj = newObject(clazz);
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	ADD_REF(obj);
 	END_EXCEPTION_HANDLING();
@@ -587,8 +587,7 @@ Kaffe_CallObjectMethodV(JNIEnv* env, job
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	ADD_REF(retval.l);
 	END_EXCEPTION_HANDLING();
@@ -624,8 +623,7 @@ Kaffe_CallObjectMethodA(JNIEnv* env, job
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.l);
@@ -644,8 +642,7 @@ Kaffe_CallBooleanMethodV(JNIEnv* env, jo
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jboolean) retval.i);
@@ -680,8 +677,7 @@ Kaffe_CallBooleanMethodA(JNIEnv* env, jo
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jboolean) retval.i);
@@ -700,8 +696,7 @@ Kaffe_CallByteMethodV(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jbyte) retval.i);
@@ -736,8 +731,7 @@ Kaffe_CallByteMethodA(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jbyte) retval.i);
@@ -756,8 +750,7 @@ Kaffe_CallCharMethodV(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jchar) retval.i);
@@ -792,8 +785,7 @@ Kaffe_CallCharMethodA(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jchar) retval.i);
@@ -812,8 +804,7 @@ Kaffe_CallShortMethodV(JNIEnv* env, jobj
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jshort) retval.i);
@@ -848,8 +839,7 @@ Kaffe_CallShortMethodA(JNIEnv* env, jobj
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jshort) retval.i);
@@ -868,8 +858,7 @@ Kaffe_CallIntMethodV(JNIEnv* env, jobjec
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.i);
@@ -904,8 +893,7 @@ Kaffe_CallIntMethodA(JNIEnv* env, jobjec
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.i);
@@ -924,8 +912,7 @@ Kaffe_CallLongMethodV(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.j);
@@ -960,8 +947,7 @@ Kaffe_CallLongMethodA(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.j);
@@ -980,8 +966,7 @@ Kaffe_CallFloatMethodV(JNIEnv* env, jobj
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.f);
@@ -1016,8 +1001,7 @@ Kaffe_CallFloatMethodA(JNIEnv* env, jobj
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.f);
@@ -1036,8 +1020,7 @@ Kaffe_CallDoubleMethodV(JNIEnv* env, job
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.d);
@@ -1072,8 +1055,7 @@ Kaffe_CallDoubleMethodA(JNIEnv* env, job
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.d);
@@ -1091,8 +1073,7 @@ Kaffe_CallVoidMethodV(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, 0);
+	callMethodV(m, obj, args, 0);
 
 	END_EXCEPTION_HANDLING();
 }
@@ -1123,8 +1104,7 @@ Kaffe_CallVoidMethodA(JNIEnv* env, jobje
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, (m->idx >= 0 ? o->dtable->method[m->idx]
-			: JNI_METHOD_CODE(m)), obj, args, 0, 0);
+	callMethodA(m, obj, args, 0, 0);
 
 	END_EXCEPTION_HANDLING();
 }
@@ -1141,7 +1121,7 @@ Kaffe_CallNonvirtualObjectMethodV(JNIEnv
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	ADD_REF(retval.l);
 	END_EXCEPTION_HANDLING();
@@ -1176,7 +1156,7 @@ Kaffe_CallNonvirtualObjectMethodA(JNIEnv
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	ADD_REF(retval.l);
 	END_EXCEPTION_HANDLING();
@@ -1195,7 +1175,7 @@ Kaffe_CallNonvirtualBooleanMethodV(JNIEn
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jboolean) retval.i);
@@ -1229,7 +1209,7 @@ Kaffe_CallNonvirtualBooleanMethodA(JNIEn
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jboolean) retval.i);
@@ -1247,7 +1227,7 @@ Kaffe_CallNonvirtualByteMethodV(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jbyte) retval.i);
@@ -1281,7 +1261,7 @@ Kaffe_CallNonvirtualByteMethodA(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jbyte) retval.i);
@@ -1299,7 +1279,7 @@ Kaffe_CallNonvirtualCharMethodV(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jchar) retval.i);
@@ -1333,7 +1313,7 @@ Kaffe_CallNonvirtualCharMethodA(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jchar) retval.i);
@@ -1351,7 +1331,7 @@ Kaffe_CallNonvirtualShortMethodV(JNIEnv*
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jshort) retval.i);
@@ -1385,7 +1365,7 @@ Kaffe_CallNonvirtualShortMethodA(JNIEnv*
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jshort) retval.i);
@@ -1403,7 +1383,7 @@ Kaffe_CallNonvirtualIntMethodV(JNIEnv* e
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.i);
@@ -1437,7 +1417,7 @@ Kaffe_CallNonvirtualIntMethodA(JNIEnv* e
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.i);
@@ -1455,7 +1435,7 @@ Kaffe_CallNonvirtualLongMethodV(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.j);
@@ -1489,7 +1469,7 @@ Kaffe_CallNonvirtualLongMethodA(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.j);
@@ -1507,7 +1487,7 @@ Kaffe_CallNonvirtualFloatMethodV(JNIEnv*
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.f);
@@ -1541,7 +1521,7 @@ Kaffe_CallNonvirtualFloatMethodA(JNIEnv*
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.f);
@@ -1559,7 +1539,7 @@ Kaffe_CallNonvirtualDoubleMethodV(JNIEnv
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, &retval);
+	callMethodV(m, obj, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.d);
@@ -1593,7 +1573,7 @@ Kaffe_CallNonvirtualDoubleMethodA(JNIEnv
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, &retval, 0);
+	callMethodA(m, obj, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.d);
@@ -1610,7 +1590,7 @@ Kaffe_CallNonvirtualVoidMethodV(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), obj, args, 0);
+	callMethodV(m, obj, args, 0);
 
 	END_EXCEPTION_HANDLING();
 }
@@ -1640,7 +1620,7 @@ Kaffe_CallNonvirtualVoidMethodA(JNIEnv* 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), obj, args, 0, 0);
+	callMethodA(m, obj, args, 0, 0);
 
 	END_EXCEPTION_HANDLING();
 }
@@ -1896,7 +1876,7 @@ Kaffe_CallStaticObjectMethodV(JNIEnv* en
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	ADD_REF(retval.l);
 	END_EXCEPTION_HANDLING();
@@ -1931,7 +1911,7 @@ Kaffe_CallStaticObjectMethodA(JNIEnv* en
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	ADD_REF(retval.l);
 	END_EXCEPTION_HANDLING();
@@ -1950,7 +1930,7 @@ Kaffe_CallStaticBooleanMethodV(JNIEnv* e
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jboolean) retval.i);
@@ -1984,7 +1964,7 @@ Kaffe_CallStaticBooleanMethodA(JNIEnv* e
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jboolean) retval.i);
@@ -2002,7 +1982,7 @@ Kaffe_CallStaticByteMethodV(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jbyte) retval.i);
@@ -2036,7 +2016,7 @@ Kaffe_CallStaticByteMethodA(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jbyte) retval.i);
@@ -2054,7 +2034,7 @@ Kaffe_CallStaticCharMethodV(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jchar) retval.i);
@@ -2088,7 +2068,7 @@ Kaffe_CallStaticCharMethodA(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jchar) retval.i);
@@ -2106,7 +2086,7 @@ Kaffe_CallStaticShortMethodV(JNIEnv* env
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return ((jshort) retval.i);
@@ -2140,7 +2120,7 @@ Kaffe_CallStaticShortMethodA(JNIEnv* env
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return ((jshort) retval.i);
@@ -2158,7 +2138,7 @@ Kaffe_CallStaticIntMethodV(JNIEnv* env, 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.i);
@@ -2192,7 +2172,7 @@ Kaffe_CallStaticIntMethodA(JNIEnv* env, 
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.i);
@@ -2210,7 +2190,7 @@ Kaffe_CallStaticLongMethodV(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.j);
@@ -2244,7 +2224,7 @@ Kaffe_CallStaticLongMethodA(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.j);
@@ -2262,7 +2242,7 @@ Kaffe_CallStaticFloatMethodV(JNIEnv* env
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.f);
@@ -2296,7 +2276,7 @@ Kaffe_CallStaticFloatMethodA(JNIEnv* env
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.f);
@@ -2314,7 +2294,7 @@ Kaffe_CallStaticDoubleMethodV(JNIEnv* en
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.d);
@@ -2348,7 +2328,7 @@ Kaffe_CallStaticDoubleMethodA(JNIEnv* en
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, &retval, 0);
+	callMethodA(m, 0, args, &retval, 0);
 
 	END_EXCEPTION_HANDLING();
 	return (retval.d);
@@ -2366,7 +2346,7 @@ Kaffe_CallStaticVoidMethodV(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodV(m, JNI_METHOD_CODE(m), 0, args, &retval);
+	callMethodV(m, 0, args, &retval);
 
 	END_EXCEPTION_HANDLING();
 }
@@ -2396,7 +2376,7 @@ Kaffe_CallStaticVoidMethodA(JNIEnv* env,
 		throwException(NoSuchMethodError(m->name->data));
 	}
 
-	callMethodA(m, JNI_METHOD_CODE(m), 0, args, 0, 0);
+	callMethodA(m, 0, args, 0, 0);
 
 	END_EXCEPTION_HANDLING();
 }
Index: kaffe/kaffevm/support.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/support.c,v
retrieving revision 1.55
diff -w -u -p -r1.55 support.c
--- kaffe/kaffevm/support.c	19 Oct 2002 10:12:02 -0000	1.55
+++ kaffe/kaffevm/support.c	27 Dec 2002 22:21:16 -0000
@@ -146,7 +146,7 @@ do_execute_java_method_v(void* obj, cons
 		throwException(NoSuchMethodError(method_name));
 	}
 
-	callMethodV(mb, METHOD_INDIRECTMETHOD(mb), obj, argptr, &retval);
+	callMethodV(mb, obj, argptr, &retval);
 
 	return (retval);
 }
@@ -200,7 +200,7 @@ do_execute_java_class_method_v(const cha
 	}
 
 	/* Make the call */
-	callMethodV(mb, METHOD_INDIRECTMETHOD(mb), 0, argptr, &retval);
+	callMethodV(mb, 0, argptr, &retval);
 
 	return (retval);
 }
@@ -267,7 +267,7 @@ execute_java_constructor_v(const char* c
 	assert(obj != 0);
 
 	/* Make the call */
-	callMethodV(mb, METHOD_INDIRECTMETHOD(mb), obj, argptr, &retval);
+	callMethodV(mb, obj, argptr, &retval);
 
 	return (obj);
 }
@@ -348,10 +348,33 @@ execute_java_constructor(const char* cna
 #endif
 
 /*
+ * Returns the function that's to be executed when meth is invoked on obj. 
+ */
+static inline void *
+findMethodFunc (Method *meth, Hjava_lang_Object *obj)
+{
+	short *implementors;
+	Hjava_lang_Class *clazz;
+
+	if (obj && CLASS_IS_INTERFACE (meth->class)) {
+		assert (meth->idx >= 0);
+
+		implementors = meth->class->implementors;
+		clazz = OBJECT_CLASS(obj);
+
+		assert (implementors != NULL && clazz->impl_index <= implementors[0]);
+		
+		return clazz->itable2dtable[implementors[clazz->impl_index] + meth->idx + 1]; 	
+	} else {
+		return METHOD_INDIRECTMETHOD (meth);
+	}
+}
+
+/*
  * Generic routine to call a native or Java method (array style).
  */
 void
-callMethodA(Method* meth, void* func, void* obj, jvalue* args, jvalue* ret,
+callMethodA(Method* meth, void* obj, jvalue* args, jvalue* ret,
 	    int promoted)
 {
 	int i;
@@ -376,7 +399,7 @@ callMethodA(Method* meth, void* func, vo
 	 * upon return from native and we will add additional parameters 
 	 * according to the JNI calling convention.
 	 */
-	meth = (Method*)func;
+	meth = (Method*)findMethodFunc (meth, (Hjava_lang_Object *)obj);
 	if (meth->accflags & ACC_NATIVE) {
 		if (!METHOD_TRANSLATED(meth)) {
 			errorInfo info;
@@ -524,7 +547,7 @@ callMethodA(Method* meth, void* func, vo
 
 
 #if defined(TRANSLATOR)
-	call.function = func;
+	call.function = findMethodFunc (meth, (Hjava_lang_Object *)obj);
 
 	/* GCDIAG wipes free memory with 0xf4... */
 	assert(call.function);
@@ -592,7 +615,7 @@ callMethodA(Method* meth, void* func, vo
  * Generic routine to call a native or Java method (varargs style).
  */
 void
-callMethodV(Method* meth, void* func, void* obj, va_list args, jvalue* ret)
+callMethodV(Method* meth, void* obj, va_list args, jvalue* ret)
 {
   /* const char* sig; FIXME */
 	int i;
@@ -611,7 +634,7 @@ callMethodV(Method* meth, void* func, vo
 	s = 0;
 
 #if defined(INTERPRETER)
-	meth = (Method*)func;
+	meth = (Method*)findMethodFunc (meth, (Hjava_lang_Object *)obj);
 	if (meth->accflags & ACC_NATIVE) {
                 if (METHOD_NATIVECODE(meth) == 0) {
 			errorInfo info;
@@ -738,9 +761,7 @@ callMethodV(Method* meth, void* func, vo
 	call.ret = ret;
 
 #if defined(TRANSLATOR)
-	assert((func == (METHOD_NATIVECODE(meth)))
-	       || (func == (((Hjava_lang_Object*)obj)->dtable->method[meth->idx])));
-	call.function = func;
+	call.function = findMethodFunc (meth, (Hjava_lang_Object *)obj);
 
 	/* GCDIAG wipes free memory with 0xf4... */
 	assert(call.function);
Index: kaffe/kaffevm/support.h
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/support.h,v
retrieving revision 1.21
diff -w -u -p -r1.21 support.h
--- kaffe/kaffevm/support.h	18 Dec 1999 07:40:25 -0000	1.21
+++ kaffe/kaffevm/support.h	27 Dec 2002 22:21:16 -0000
@@ -119,8 +119,8 @@ extern struct Hjava_lang_Object* execute
 extern jlong		currentTime(void);
 extern void		addNativeMethod(const char*, void*);
 
-extern void	callMethodA(struct _methods*, void*, void*, jvalue*, jvalue*, int);
-extern void	callMethodV(struct _methods*, void*, void*, va_list, jvalue*);
+extern void	callMethodA(struct _methods*, void*, jvalue*, jvalue*, int);
+extern void	callMethodV(struct _methods*, void*, va_list, jvalue*);
 extern struct _methods*	lookupClassMethod(struct Hjava_lang_Class*, const char*, const char*, struct _errorInfo*);
 extern struct _methods*	lookupObjectMethod(struct Hjava_lang_Object*, const char*, const char*, struct _errorInfo*);
 
